# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# --------------------------------------------------------------------------------------------


class Constants(object):  # pylint: disable=too-few-public-methods
    SouthCentralUS = "SouthCentralUS"
    ArmSchemaVersion = "http://schema.management.azure.com/schemas/2014-04-01-preview/deploymentTemplate.json"
    ContentVersion = "1.0.0.0"
    SfResourceFileNameFormat = "sf*.yaml"
    SchemaVersion = "schemaVersion"
    PrimaryPropertyName = "name"
    FullyQualifiedResourceNameSeparator = '/'

    # RP API Versions.
    RpApiVersion_2018_03_01_privatepreview = "2018-03-01-privatepreview"
    RpApiVersion_2018_07_01_preview = "2018-07-01-preview"
    RpApiVersion_2018_09_01_preview = "2018-09-01-preview"

    # Schema versions in yamls generated by VS.
    SchemaVersion_2018_07_01_preview = "2018-07-01-preview"
    SchemaVersion_1_0_0 = "1.0.0"
    SchemaVersion_1_0_0_preview1 = "1.0.0-preview1"
    SchemaVersion_1_0_0_preview2 = "1.0.0-preview2"

    # Service Fabric REST api version
    FabricApiVersion_6_3_preview = "6.3-preview"
    FabricApiVersion_6_4_preview = "6.4-preview"

    DefaultSchemaVersion = SchemaVersion_1_0_0_preview2

    MicrosoftServiceFabric = "Microsoft.ServiceFabric"
    MicrosoftServiceFabricMesh = "Microsoft.ServiceFabricMesh"

    Application = "application"
    Volume = "volume"
    Network = "network"
    Gateway = "gateway"
    Secret = "secret"
    SecretValue = "secretValue"

    Applications = "applications"
    Volumes = "volumes"
    Secrets = "secrets"
    SecretValues = "secrets/values"
    Networks = "networks"
    Services = "services"
    Gateways = "gateways"
    Values = "values"
